"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
import pydantic
from typing_extensions import Annotated, TypedDict
from unkey_py import utils
from unkey_py.types import BaseModel


class ErrNotFoundCode(str, Enum):
    r"""A machine readable error code."""

    NOT_FOUND = "NOT_FOUND"


class ErrNotFoundErrorTypedDict(TypedDict):
    code: ErrNotFoundCode
    r"""A machine readable error code."""
    docs: str
    r"""A link to our documentation with more details about this error code"""
    message: str
    r"""A human readable explanation of what went wrong"""
    request_id: str
    r"""Please always include the requestId in your error report"""


class ErrNotFoundError(BaseModel):
    code: ErrNotFoundCode
    r"""A machine readable error code."""

    docs: str
    r"""A link to our documentation with more details about this error code"""

    message: str
    r"""A human readable explanation of what went wrong"""

    request_id: Annotated[str, pydantic.Field(alias="requestId")]
    r"""Please always include the requestId in your error report"""


class ErrNotFoundData(BaseModel):
    error: ErrNotFoundError


class ErrNotFound(Exception):
    data: ErrNotFoundData

    def __init__(self, data: ErrNotFoundData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, ErrNotFoundData)
