"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
import pydantic
from typing_extensions import Annotated, TypedDict
from unkey_py import utils
from unkey_py.types import BaseModel


class ErrTooManyRequestsCode(str, Enum):
    r"""A machine readable error code."""

    TOO_MANY_REQUESTS = "TOO_MANY_REQUESTS"


class ErrTooManyRequestsErrorTypedDict(TypedDict):
    code: ErrTooManyRequestsCode
    r"""A machine readable error code."""
    docs: str
    r"""A link to our documentation with more details about this error code"""
    message: str
    r"""A human readable explanation of what went wrong"""
    request_id: str
    r"""Please always include the requestId in your error report"""


class ErrTooManyRequestsError(BaseModel):
    code: ErrTooManyRequestsCode
    r"""A machine readable error code."""

    docs: str
    r"""A link to our documentation with more details about this error code"""

    message: str
    r"""A human readable explanation of what went wrong"""

    request_id: Annotated[str, pydantic.Field(alias="requestId")]
    r"""Please always include the requestId in your error report"""


class ErrTooManyRequestsData(BaseModel):
    error: ErrTooManyRequestsError


class ErrTooManyRequests(Exception):
    data: ErrTooManyRequestsData

    def __init__(self, data: ErrTooManyRequestsData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, ErrTooManyRequestsData)
